Index: /trunk/Cocoa/Pester/Source/MoreSecurity/MoreSetup.h
===================================================================
--- /trunk/Cocoa/Pester/Source/MoreSecurity/MoreSetup.h	(revision 118)
+++ /trunk/Cocoa/Pester/Source/MoreSecurity/MoreSetup.h	(revision 118)
@@ -0,0 +1,249 @@
+/*
+	File:		MoreSetup.h
+
+	Contains:	Sets up conditions etc for MoreIsBetter.
+
+	Written by:	Pete Gontier
+
+	Copyright:	Copyright (c) 1998-2001 by Apple Computer, Inc., All Rights Reserved.
+
+	Disclaimer:	IMPORTANT:  This Apple software is supplied to you by Apple Computer, Inc.
+				("Apple") in consideration of your agreement to the following terms, and your
+				use, installation, modification or redistribution of this Apple software
+				constitutes acceptance of these terms.  If you do not agree with these terms,
+				please do not use, install, modify or redistribute this Apple software.
+
+				In consideration of your agreement to abide by the following terms, and subject
+				to these terms, Apple grants you a personal, non-exclusive license, under AppleÕs
+				copyrights in this original Apple software (the "Apple Software"), to use,
+				reproduce, modify and redistribute the Apple Software, with or without
+				modifications, in source and/or binary forms; provided that if you redistribute
+				the Apple Software in its entirety and without modifications, you must retain
+				this notice and the following text and disclaimers in all such redistributions of
+				the Apple Software.  Neither the name, trademarks, service marks or logos of
+				Apple Computer, Inc. may be used to endorse or promote products derived from the
+				Apple Software without specific prior written permission from Apple.  Except as
+				expressly stated in this notice, no other rights or licenses, express or implied,
+				are granted by Apple herein, including but not limited to any patent rights that
+				may be infringed by your derivative works or by other works in which the Apple
+				Software may be incorporated.
+
+				The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO
+				WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
+				WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+				PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE OR IN
+				COMBINATION WITH YOUR PRODUCTS.
+
+				IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR
+				CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
+				GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+				ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION
+				OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT
+				(INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN
+				ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+	Change History (most recent first):
+
+$Log: MoreSetup.h,v $
+Revision 1.14  2002/11/08 22:43:02  eskimo1
+A bunch of key changes. We no longer include <Carbon/Carbon.h> in the Mach-O builds, which means that individual MoreIsBetter modules can decide what frameworks they're dependent on. Also changed MoreIsBetter to use the standard C assert mechanism.
+
+Revision 1.13  2001/11/07 15:55:15  eskimo1
+Tidy up headers, add CVS logs, update copyright.
+
+
+        <12>     21/9/01    Quinn   Fix CF framework includes workaround.
+        <11>     21/9/01    Quinn   Changes for CWPro7 Mach-O build.
+        <10>     15/2/01    Quinn   MoreIsBetter now requires UI 3.4 (pre-release) or later.
+         <9>      8/2/01    Quinn   Modern versions of MIB require UI 3.3.2 or higher.
+         <8>    22/11/00    Quinn   Switch to "MacErrors.h".
+         <7>     22/4/99    Quinn   Add a check for the Universal Interfaces version.  MoreIsBetter
+                                    requires Universal Interfaces 3.2 or higher (because many of its
+                                    component parts do).
+         <6>     2/11/99    PCG     add comments because Andy rightfully pointed out my original
+                                    attempts sucked; also, remove some excessive TARGET_CARBON
+                                    gymnastics
+         <5>     1/22/99    PCG     TARGET_CARBON
+         <4>    11/11/98    PCG     fix header
+         <3>    11/10/98    PCG     separate change histories
+         <2>    10/11/98    Quinn   Convert "MorePrefix.h" to "MoreSetup.h".
+         <1>    10/11/98    Quinn   Changed name from "MorePrefix.h" to "MoreSetup.h".
+
+	Start of "MorePrefix.h" change history (most recent first):
+
+         <3>     5/11/98    Quinn   Use MoreAssertQ instead of MoreAssert.
+         <2>     7/24/98    PCG	    rid of triplet #includes
+         <2>     6/23/98    PCG     add copyright disclaimer stuff
+         <1>     6/23/98    PCG     initial checkin
+*/
+
+#pragma once
+
+	//
+	//	We never want to use old names or locations.
+	//	Since these settings must be consistent all the way through
+	//	a compilation unit, and since we don't want to silently
+	//	change them out from under a developer who uses a prefix
+	//	file (C/C++ panel of Target Settings), we simply complain
+	//	if they are already set in a way we don't like.
+	//
+
+#ifndef OLDROUTINELOCATIONS
+	#define OLDROUTINELOCATIONS 0
+#elif OLDROUTINELOCATIONS
+	#error OLDROUTINELOCATIONS must be FALSE when compiling MoreIsBetter.
+#endif
+
+#ifndef OLDROUTINENAMES
+	#define OLDROUTINENAMES 0
+#elif OLDROUTINENAMES
+	#error OLDROUTINENAMES must be FALSE when compiling MoreIsBetter.
+#endif
+
+	//
+	//	The next statement sets up the various TARGET_xxx 
+	//	variables needed later in this file.
+	//
+	
+#include <TargetConditionals.h>
+
+	//
+	//  "TargetConditionals.h" on Mac OS X doesn't define 
+	//  TARGET_API_MAC_CARBON, which is kinda annoying.  So, 
+	//  if we're building for Mach-O and it hasn't been set, 
+	//  set it.  All Mach-O builds are inherently Carbon builds.
+	//
+	//  Note that we *have* to set TARGET_API_MAC_CARBON because 
+	//  MoreIsBetter code tests it.  However, we also want to set 
+	//  the other values because otherwise GCC won't use its 
+	//  precompiled header.  I thought about fixing this by 
+	//  including <ConditionalMacros.h> via <CoreServices/CoreServices.h>, 
+	//  but the whole goal of using <TargetConditionals.h> was to 
+	//  allow MoreIsBetter projects to have no dependencies on 
+	//  frameworks beyond System.framework.
+	//
+
+#if TARGET_RT_MAC_MACHO
+	#define TARGET_API_MAC_OS8 0
+	#define TARGET_API_MAC_CARBON 1
+	#define TARGET_API_MAC_OSX 1
+#endif
+
+	//
+	//	We need a master conditional to determine whether to use 
+	//	framework notation to reference include files.  There is 
+	//  no good way to determine whether the source tree 
+	//  is using framework includes or not, so we make a guess and 
+	//  say that Mach-O implies framework includes.  However, 
+	//  if you're building CFM with framework includes (which is 
+	//  possible, although somewhat tricky), you'll have to 
+	//  override this.
+	//
+
+#if !defined(MORE_FRAMEWORK_INCLUDES)
+	#if TARGET_RT_MAC_MACHO
+		#define MORE_FRAMEWORK_INCLUDES 1
+	#else
+		#define MORE_FRAMEWORK_INCLUDES 0
+	#endif
+#endif
+
+	//
+	//	The following works around a problem in <CoreFoundation/CFBase.h>
+	//	in Mac OS X.  CF is assuming that the CW Mach-O compiler 
+	//	would not use framework includes, which is not the case for the 
+	//	CWPro7 and later compilers.  We only do this for the CW build 
+    //	because otherwise the presence of the define prevents Project Builder 
+    //	from using Carbon's precompiled header.
+	//
+	
+#if MORE_FRAMEWORK_INCLUDES
+	#if defined(__MWERKS__)
+		#if !defined(__CF_USE_FRAMEWORK_INCLUDES__)
+		    #define __CF_USE_FRAMEWORK_INCLUDES__ 1
+		#endif
+	#endif
+#endif
+
+	// 
+	//	Previouly we would bring in <MacErrors.h> at this point.
+	//	However, that's somewhat counter to the idea behind flat 
+	//	includes, so I've eliminated it.
+	//
+
+	//
+	//	Now that we've included a Mac OS interface file,
+	//	we know that the Universal Interfaces environment
+	//	is set up.  MoreIsBetter requires Universal Interfaces
+	//	3.4 or higher.  Check for it.  Of course, "TargetConditionals.h" 
+	//  on Mac OS X doesn't set UNIVERSAL_INTERFACES_VERSION, so 
+	//  we only check this if we're not using framework includes.
+	//
+
+#if !MORE_FRAMEWORK_INCLUDES
+	#if !defined(UNIVERSAL_INTERFACES_VERSION) || UNIVERSAL_INTERFACES_VERSION < 0x0341
+		#error MoreIsBetter requires Universal Interfaces 3.4.1 or higher.
+	#endif
+#endif
+
+	//
+	//	We usually want assertions and other debugging code
+	//	turned on, but you can turn it all off if you like
+	//	by setting MORE_DEBUG to 0.  Also, now that we use 
+	//  the standard C assertion mechanism, we default to 
+	//  have MORE_DEBUG off if NDEBUG is set.
+	//
+
+#if !defined(MORE_DEBUG)
+	#if defined(NDEBUG)
+		#define MORE_DEBUG 0
+	#else
+		#define MORE_DEBUG 1
+	#endif
+#endif
+
+	//
+	//  We now use standard C assertions throughout MoreIsBetter.
+	//  Previously we would declare two custom assertion macros, 
+	//  MoreAssert and MoreAssertQ.
+	//
+	//	Our assertion macros compile down to nothing if
+	//	MORE_DEBUG is not true. MoreAssert produces a
+	//	value indicating whether the assertion succeeded
+	//	or failed. MoreAssertQ is Quinn's flavor of
+	//	MoreAssert which does not produce a value.
+	//
+
+#include <assert.h>
+
+	//
+	//  Chances are that if you're building CFM then you'd much 
+	//  rather have assert triggered DebugStr that abort.  The 
+	//  following redefines assert that way.  We don't do this 
+	//  for Mach-O because you might be building a Mach-O tool that 
+	//  doesn't have access to DebugStr.
+	// 
+	
+#if TARGET_RT_MAC_CFM && !defined(NDEBUG)
+	#undef assert
+	#define assert(x) ((x) ? ((void) 0) : DebugStr("\pMoreIsBetter assertion failure: " #x))
+#endif
+
+	// 
+	//  Finally, we define MoreAssertPCG, to accomodate some 
+	//  older MoreIsBetter code that tests the result of its 
+	//  assertions.  This doesn't fit in with the standard C 
+	//  assert model, so I've deprecated the approach.  However
+	//  there's a bunch of existing code that works that way 
+	//  and reworking it would be likely to generate errors. 
+	//  Fortunately, all of the old code that uses this is 
+	//  Carbon based, so I don't have to worry about not having 
+	//  access to DebugStr.
+	// 
+	
+#if MORE_DEBUG
+	#define MoreAssertPCG(x) \
+		((x) ? true : (DebugStr ("\pMoreIsBetter assertion failure: " #x), false))
+#else
+	#define MoreAssertPCG(x) (true)
+#endif
Index: /trunk/Cocoa/Pester/Source/MoreSecurity/MoreUNIX.c
===================================================================
--- /trunk/Cocoa/Pester/Source/MoreSecurity/MoreUNIX.c	(revision 118)
+++ /trunk/Cocoa/Pester/Source/MoreSecurity/MoreUNIX.c	(revision 118)
@@ -0,0 +1,431 @@
+/*
+	File:		MoreUNIX.c
+
+	Contains:	Generic UNIX utilities.
+
+	Written by:	Quinn
+
+	Copyright:	Copyright (c) 2002 by Apple Computer, Inc., All Rights Reserved.
+
+	Disclaimer:	IMPORTANT:  This Apple software is supplied to you by Apple Computer, Inc.
+				("Apple") in consideration of your agreement to the following terms, and your
+				use, installation, modification or redistribution of this Apple software
+				constitutes acceptance of these terms.  If you do not agree with these terms,
+				please do not use, install, modify or redistribute this Apple software.
+
+				In consideration of your agreement to abide by the following terms, and subject
+				to these terms, Apple grants you a personal, non-exclusive license, under AppleÕs
+				copyrights in this original Apple software (the "Apple Software"), to use,
+				reproduce, modify and redistribute the Apple Software, with or without
+				modifications, in source and/or binary forms; provided that if you redistribute
+				the Apple Software in its entirety and without modifications, you must retain
+				this notice and the following text and disclaimers in all such redistributions of
+				the Apple Software.  Neither the name, trademarks, service marks or logos of
+				Apple Computer, Inc. may be used to endorse or promote products derived from the
+				Apple Software without specific prior written permission from Apple.  Except as
+				expressly stated in this notice, no other rights or licenses, express or implied,
+				are granted by Apple herein, including but not limited to any patent rights that
+				may be infringed by your derivative works or by other works in which the Apple
+				Software may be incorporated.
+
+				The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO
+				WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
+				WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+				PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE OR IN
+				COMBINATION WITH YOUR PRODUCTS.
+
+				IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR
+				CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
+				GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+				ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION
+				OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT
+				(INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN
+				ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+	Change History (most recent first):
+
+$Log: MoreUNIX.c,v $
+Revision 1.4  2002/12/13 00:30:18  eskimo1
+10.1 compatibility. futimes isn't available in 10.1. Drat! Also, in NSGetExecutablePathOnTenOneAndEarlierOnly, have to skip over multiple NULLs between the environment and the relative path point, in case someone (like MoreSecDestroyInheritedEnvironment perhaps) has called unsetenv.
+
+Revision 1.3  2002/12/12 23:14:29  eskimo1
+C++ compatibility.
+
+Revision 1.2  2002/11/14 20:15:20  eskimo1
+In MoreUNIXCopyFile, correctly set the modified and accessed times of the resulting file.
+
+Revision 1.1  2002/11/09 00:15:21  eskimo1
+A collection of useful UNIX-level routines.
+
+
+*/
+
+/////////////////////////////////////////////////////////////////
+
+// Our prototypes
+
+#include "MoreUNIX.h"
+
+// System interfaces
+
+#include <sys/param.h>
+#include <mach-o/dyld.h>
+#include <stdio.h>
+#include <string.h>
+#include <assert.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <unistd.h>
+#include <signal.h>
+#include <fcntl.h>
+#include <sys/stat.h>
+#include <stdbool.h>
+
+// "crt_externs.h" has no C++ guards [3126393], so we have to provide them 
+// ourself otherwise we get a link error.
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <crt_externs.h>
+
+#ifdef __cplusplus
+}
+#endif
+
+// MIB Interfaces
+
+/////////////////////////////////////////////////////////////////
+
+#if MORE_DEBUG
+
+	// There's a macro version of this in the header.
+	
+	extern int MoreUNIXErrno(int result)
+	{
+		int err;
+		
+		err = 0;
+		if (result < 0) {
+			err = errno;
+			assert(err != 0);
+		}
+		return err;
+	}
+
+#endif
+
+/////////////////////////////////////////////////////////////////
+
+static int NSGetExecutablePathOnTenOneAndEarlierOnly(char *execPath, size_t *execPathSize)
+{
+    int  	err = 0;
+    char 	**cursor;
+    char 	*possiblyRelativePath;
+    char 	absolutePath[MAXPATHLEN];
+    size_t 	absolutePathSize;
+    
+    assert(execPath != NULL);
+    assert(execPathSize != NULL);
+    
+    cursor = (char **) (*(_NSGetArgv()) + *(_NSGetArgc()));
+    
+    // There should be a NULL after the argv array.
+    // If not, error out.
+    
+    if (*cursor != 0) {
+        err = -1;
+	}
+    
+    if (err == 0) {
+        // Skip past the NULL after the argv array.
+        
+        cursor += 1;
+        
+        // Now, skip over the entire kernel-supplied environment, 
+        // which is an array of char * terminated by a NULL.
+        
+        while (*cursor != 0) {
+            cursor += 1;
+        }
+        
+        // Skip over the NULL terminating the environment.  Actually, 
+        // there can be multiple NULLs if the program has called 
+        // unsetenv, so we skip along until we find a the next non-NULL.
+        
+        while (*cursor == 0) {
+            cursor += 1;
+        }
+
+        // Now we have the path that was passed to exec 
+        // (not the argv[0] path, but the path that the kernel 
+        // actually executed).
+        
+        possiblyRelativePath = *cursor;
+
+        // Convert the possibly relative path to an absolute 
+        // path.  We use realpath for expedience, although 
+        // the real implementation of _NSGetExecutablePath
+        // uses getcwd and can return a path with symbolic links 
+        // etc in it.
+        
+        if (realpath(possiblyRelativePath, absolutePath) == NULL) {
+            err = errno;
+		}
+    }
+    
+    // Now copy the path out into the client's buffer, returning 
+    // an error if the buffer isn't big enough.
+    
+    if (err == 0) {
+        absolutePathSize = (strlen(absolutePath) + 1);
+        
+        if (absolutePathSize <= *execPathSize) {
+            strcpy(execPath, absolutePath);
+        } else {
+            err = -1;
+        }
+        
+        *execPathSize = absolutePathSize;
+    }
+
+    return err;
+}
+
+typedef int (*NSGetExecutablePathProcPtr)(char *buf, size_t *bufsize);
+
+extern int MoreGetExecutablePath(char *execPath, size_t *execPathSize)
+{
+    if (NSIsSymbolNameDefined("__NSGetExecutablePath")) {
+        return ((NSGetExecutablePathProcPtr) NSAddressOfSymbol(NSLookupAndBindSymbol("__NSGetExecutablePath")))(execPath, execPathSize);
+    } else {
+        // The function _NSGetExecutablePath() is new in Mac OS X 10.2, 
+        // so use this custom version when running on 10.1.x and earlier.
+        return NSGetExecutablePathOnTenOneAndEarlierOnly(execPath, execPathSize);
+    }
+}
+
+/////////////////////////////////////////////////////////////////
+
+extern int MoreUNIXRead( int fd,       void *buf, size_t bufSize, size_t *bytesRead   )
+	// See comment in header.
+{
+	int 	err;
+	char *	cursor;
+	size_t	bytesLeft;
+	ssize_t bytesThisTime;
+
+	assert(fd >= 0);
+	assert(buf != NULL);
+	
+	err = 0;
+	bytesLeft = bufSize;
+	cursor = (char *) buf;
+	while ( (err == 0) && (bytesLeft != 0) ) {
+		bytesThisTime = read(fd, cursor, bytesLeft);
+		if (bytesThisTime > 0) {
+			cursor    += bytesThisTime;
+			bytesLeft -= bytesThisTime;
+		} else if (bytesThisTime == 0) {
+			err = EPIPE;
+		} else {
+			assert(bytesThisTime == -1);
+			
+			err = errno;
+			assert(err != 0);
+			if (err == EINTR) {
+				err = 0;		// let's loop again
+			}
+		}
+	}
+	if (bytesRead != NULL) {
+		*bytesRead = bufSize - bytesLeft;
+	}
+	
+	return err;
+}
+
+extern int MoreUNIXWrite(int fd, const void *buf, size_t bufSize, size_t *bytesWritten)
+	// See comment in header.
+{
+	int 	err;
+	char *	cursor;
+	size_t	bytesLeft;
+	ssize_t bytesThisTime;
+	
+	assert(fd >= 0);
+	assert(buf != NULL);
+	
+	// SIGPIPE occurs when you write to pipe or socket 
+	// whose other end has been closed.  The default action 
+	// for SIGPIPE is to terminate the process.  That's 
+	// probably not what you wanted.  So, in the debug build, 
+	// we check that you've set the signal action to SIG_IGN 
+	// (ignore).  Of course, you could be building a program 
+	// that needs SIGPIPE to work in some special way, in 
+	// which case you should define MORE_UNIX_WRITE_CHECK_SIGPIPE 
+	// to 0 to bypass this check.
+	//
+	// MoreUNIXIgnoreSIGPIPE, a helper routine defined below, 
+	// lets you disable SIGPIPE easily.
+	
+	#if !defined(MORE_UNIX_WRITE_CHECK_SIGPIPE)
+		#define MORE_UNIX_WRITE_CHECK_SIGPIPE 1
+	#endif
+	#if MORE_DEBUG && MORE_UNIX_WRITE_CHECK_SIGPIPE
+		{
+			int junk;
+			struct sigaction currentSignalState;
+			
+			junk = sigaction(SIGPIPE, NULL, &currentSignalState);
+			assert(junk == 0);
+			
+			assert( currentSignalState.sa_handler == SIG_IGN );
+		}
+	#endif
+
+	err = 0;
+	bytesLeft = bufSize;
+	cursor = (char *) buf;
+	while ( (err == 0) && (bytesLeft != 0) ) {
+		bytesThisTime = write(fd, cursor, bytesLeft);
+		if (bytesThisTime > 0) {
+			cursor    += bytesThisTime;
+			bytesLeft -= bytesThisTime;
+		} else if (bytesThisTime == 0) {
+			assert(false);
+			err = EPIPE;
+		} else {
+			assert(bytesThisTime == -1);
+			
+			err = errno;
+			assert(err != 0);
+			if (err == EINTR) {
+				err = 0;		// let's loop again
+			}
+		}
+	}
+	if (bytesWritten != NULL) {
+		*bytesWritten = bufSize - bytesLeft;
+	}
+	
+	return err;
+}
+
+extern int MoreUNIXIgnoreSIGPIPE(void)
+	// See comment in header.
+{
+	int err;
+	struct sigaction signalState;
+	
+	err = sigaction(SIGPIPE, NULL, &signalState);
+	err = MoreUNIXErrno(err);
+	if (err == 0) {
+		signalState.sa_handler = SIG_IGN;
+		
+		err = sigaction(SIGPIPE, &signalState, NULL);
+		err = MoreUNIXErrno(err);
+	}
+	
+	return err;
+}
+
+extern int MoreUNIXCopyDescriptorToDescriptor(int source, int dest)
+	// See comment in header.
+{
+	int		err;
+	bool    done;
+	char *  buffer;
+	static const size_t kBufferSize = 64 * 1024;
+	
+	assert(source >= 0);
+	assert(dest   >= 0);
+	
+	err = 0;
+	buffer = (char *) malloc(kBufferSize);
+	if (buffer == NULL) {
+		err = ENOMEM;
+	}
+
+	if (err == 0) {	
+		done = false;
+		do {
+			size_t bytesRead;
+			
+			err = MoreUNIXRead(source, buffer, kBufferSize, &bytesRead);
+			if (err == EPIPE) {
+				done = true;
+				err = 0;
+			}
+			if (err == 0) {
+				err = MoreUNIXWrite(dest, buffer, bytesRead, NULL);
+			}
+		} while (err == 0 && !done);
+	}
+	
+	free(buffer);
+	
+	return err;
+}
+
+extern int MoreUNIXCopyFile(const char *source, const char *dest)
+	// See comment in header.
+{
+	int 		err;
+	int 		junk;
+	int 		sourceFD;
+	int 		destFD;
+	struct stat sb;
+	
+	assert(source != NULL);
+	assert(dest   != NULL);
+	
+	sourceFD = -1;
+	destFD   = -1;
+
+	err = stat(source, &sb);
+	err = MoreUNIXErrno(err);
+	
+	if (err == 0) {
+		sourceFD = open(source, O_RDONLY, 0);
+		err = MoreUNIXErrno(sourceFD);
+	}
+	
+	if (err == 0) {
+		destFD = open(dest, O_WRONLY | O_CREAT | O_TRUNC, sb.st_mode & ~(S_ISUID | S_ISGID | S_ISVTX));
+		err = MoreUNIXErrno(destFD);
+	}
+	
+	if (err == 0) {
+		err = MoreUNIXCopyDescriptorToDescriptor(sourceFD, destFD);
+	}
+
+	// Close the descriptors.
+	
+	if (sourceFD != -1) {
+		junk = close(sourceFD);
+		assert(junk == 0);
+	}
+	if (destFD != -1) {
+		junk = close(destFD);
+		assert(junk == 0);
+	}
+
+	// Set the access and modification times of the destination 
+	// to match the source.  I originally did this using futimes, 
+	// but hey, that's not available on 10.1, so now I do it 
+	// using utimes.  *sigh*
+	
+	if (err == 0) {
+		struct timeval times[2];
+		
+		TIMESPEC_TO_TIMEVAL(&times[0], &sb.st_atimespec);
+		TIMESPEC_TO_TIMEVAL(&times[1], &sb.st_mtimespec);
+		
+		err = utimes(dest, times);
+		err = MoreUNIXErrno(err);
+	}
+
+	return err;
+}
Index: /trunk/Cocoa/Pester/Source/MoreSecurity/MoreUNIX.h
===================================================================
--- /trunk/Cocoa/Pester/Source/MoreSecurity/MoreUNIX.h	(revision 118)
+++ /trunk/Cocoa/Pester/Source/MoreSecurity/MoreUNIX.h	(revision 118)
@@ -0,0 +1,154 @@
+/*
+	File:		MoreUNIX.h
+
+	Contains:	Generic UNIX utilities.
+
+	Written by:	Quinn
+
+	Copyright:	Copyright (c) 2002 by Apple Computer, Inc., All Rights Reserved.
+
+	Disclaimer:	IMPORTANT:  This Apple software is supplied to you by Apple Computer, Inc.
+				("Apple") in consideration of your agreement to the following terms, and your
+				use, installation, modification or redistribution of this Apple software
+				constitutes acceptance of these terms.  If you do not agree with these terms,
+				please do not use, install, modify or redistribute this Apple software.
+
+				In consideration of your agreement to abide by the following terms, and subject
+				to these terms, Apple grants you a personal, non-exclusive license, under AppleÕs
+				copyrights in this original Apple software (the "Apple Software"), to use,
+				reproduce, modify and redistribute the Apple Software, with or without
+				modifications, in source and/or binary forms; provided that if you redistribute
+				the Apple Software in its entirety and without modifications, you must retain
+				this notice and the following text and disclaimers in all such redistributions of
+				the Apple Software.  Neither the name, trademarks, service marks or logos of
+				Apple Computer, Inc. may be used to endorse or promote products derived from the
+				Apple Software without specific prior written permission from Apple.  Except as
+				expressly stated in this notice, no other rights or licenses, express or implied,
+				are granted by Apple herein, including but not limited to any patent rights that
+				may be infringed by your derivative works or by other works in which the Apple
+				Software may be incorporated.
+
+				The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO
+				WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
+				WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+				PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE OR IN
+				COMBINATION WITH YOUR PRODUCTS.
+
+				IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR
+				CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
+				GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+				ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION
+				OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT
+				(INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN
+				ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+	Change History (most recent first):
+
+$Log: MoreUNIX.h,v $
+Revision 1.2  2002/11/14 20:15:23  eskimo1
+In MoreUNIXCopyFile, correctly set the modified and accessed times of the resulting file.
+
+Revision 1.1  2002/11/09 00:15:24  eskimo1
+A collection of useful UNIX-level routines.
+
+
+*/
+
+#pragma once
+
+/////////////////////////////////////////////////////////////////
+
+// MoreIsBetter Setup
+
+#include "MoreSetup.h"
+
+#if !TARGET_RT_MAC_MACHO
+	#error MoreUNIX requires the use of Mach-O
+#endif
+
+// System prototypes
+
+#include <stdlib.h>
+
+/////////////////////////////////////////////////////////////////
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+// Macros that act like functions to convert OSStatus error codes to errno-style 
+// error codes, and vice versa.  Right now these are just pass throughs because 
+// OSStatus errors are 32 bit signed values that are generally negative, and 
+// errno errors are 32 bit signed values that are small positive.
+
+#define OSStatusToEXXX(os) ((int) (os))
+#define EXXXToOSStatus(ex) ((OSStatus) (ex))
+
+// A mechanism to extra errno if a function fails.  You typically use this as 
+//
+//   fd = open(...);
+//   err = MoreUNIXErrno(fd);
+//
+// or
+//
+//   err = setuid(0);
+//   err = MoreUNIXErrno(err);
+
+#if MORE_DEBUG
+
+	extern int MoreUNIXErrno(int result);
+
+#else
+
+	#define MoreUNIXErrno(err) (((err) < 0) ? errno : 0)
+
+#endif
+
+/////////////////////////////////////////////////////////////////
+
+extern int MoreGetExecutablePath(char *execPath, size_t *execPathSize);
+	// Returns the path to the current executable in execPath. 
+	// On input, execPathSize is the size of the execPath buffer.
+	// On output, execPathSize is the size of the path placed in 
+	// that buffer.
+	// Result is an errno error code.
+
+/////////////////////////////////////////////////////////////////
+
+extern int MoreUNIXRead( int fd,       void *buf, size_t bufSize, size_t *bytesRead   );
+	// A wrapper around "read" that keeps reading until either 
+	// bufSize bytes are read or until EOF is encountered, 
+	// in which case you get EPIPE.
+	//
+	// If bytesRead is not NULL, *bytesRead will be set to the number 
+	// of bytes successfully read.
+
+extern int MoreUNIXWrite(int fd, const void *buf, size_t bufSize, size_t *bytesWritten);
+	// A wrapper around "write" that keeps writing until either 
+	// all the data is written or an error occurs, in which case 
+	// you get EPIPE.
+	//
+	// If bytesWritten is not NULL, *bytesWritten will be set to the number 
+	// of bytes successfully written.
+
+extern int MoreUNIXIgnoreSIGPIPE(void);
+	// Sets the handler for SIGPIPE to SIG_IGN.  If you don't call 
+	// this, writing to a broken pipe will cause SIGPIPE (rather 
+	// than having "write" return EPIPE), which is hardly ever 
+	// what you want.
+
+extern int MoreUNIXCopyDescriptorToDescriptor(int source, int dest);
+	// A naive copy engine, that copies from source to dest 
+	// until EOF is encountered on source.  Not meant for 
+	// copying large amounts of data.
+	
+extern int MoreUNIXCopyFile(const char *source, const char *dest);
+	// A very naive file copy implementation, that just opens 
+	// up source and dest and copies the contents across 
+	// using MoreUNIXCopyDescriptorToDescriptor.
+	// It does, however, handle setting the mode and access/modification 
+	// times of dest properly.
+
+#ifdef __cplusplus
+}
+#endif
Index: /trunk/Cocoa/Pester/Source/PSPowerManager.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 117)
+++ /trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 118)
@@ -10,4 +10,6 @@
 #import <IOKit/IOKitLib.h>
 
+extern NSString * const PSPowerManagerException;
+
 @interface PSPowerManager : NSObject {
     id delegate;
@@ -19,6 +21,8 @@
 
 + (BOOL)autoWakeSupported;
++ (void)authorize;
 + (NSDate *)wakeTime;
-+ (void)setWakeTime:(NSDate *)time;
++ (void)setWakeInterval:(unsigned long)wakeInterval;
++ (void)setWakeTime:(NSDate *)time overrideIfEarlier:(BOOL)override;
 + (void)clearWakeTime;
 
